"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _bind = _interopRequireDefault(require("classnames/bind"));

var _terraThemeContext = _interopRequireDefault(require("terra-theme-context"));

var _SpacerModule = _interopRequireDefault(require("./Spacer.module.scss"));

var _spacerShorthandUtils = require("./_spacerShorthandUtils");

var _spacerConstants = require("./_spacerConstants");

var _excluded = ["margin", "marginTop", "marginBottom", "marginLeft", "marginRight", "padding", "paddingTop", "paddingBottom", "paddingLeft", "paddingRight", "isInlineBlock", "children"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var cx = _bind.default.bind(_SpacerModule.default);
/*
  NOTE: this is needed in order to ensure that the types `marginTop`, `marginRight`, `paddingTop`, `paddingRight`, etc. are recognized by terra-props-table
  as defined. Currently, simply putting `Object.values(SpacerSizes)` causes all other `marginX` and `paddingX` props to be recognized as `undefined`
  in the PropsTable.
*/


var arrayOfSpacerSizes = ['none', 'small-2', 'small-1', 'small', 'medium', 'large', 'large+1', 'large+2', 'large+3', 'large+4'];
var propTypes = {
  /**
   * Child Nodes.
   */
  children: _propTypes.default.node.isRequired,

  /**
   * Sets margin in a syntax similar to the standard CSS spec https://developer.mozilla.org/en-US/docs/Web/CSS/margin. One of 'none', 'small-2', 'small-1', 'small', 'medium', 'large', 'large+1', 'large+2', 'large+3', 'large+4'.
   */
  margin: _spacerShorthandUtils.shorthandValidator,

  /**
   * Sets top margin. One of 'none', 'small-2', 'small-1', 'small', 'medium', 'large', 'large+1', 'large+2', 'large+3', 'large+4'.
   */
  marginTop: _propTypes.default.oneOf(arrayOfSpacerSizes),

  /**
   * Sets bottom margin. One of 'none', 'small-2', 'small-1', 'small', 'medium', 'large', 'large+1', 'large+2', 'large+3', 'large+4'.
   */
  marginBottom: _propTypes.default.oneOf(arrayOfSpacerSizes),

  /**
   * Sets left margin One of 'none', 'small-2', 'small-1', 'small', 'medium', 'large', 'large+1', 'large+2', 'large+3', 'large+4'.
   */
  marginLeft: _propTypes.default.oneOf(arrayOfSpacerSizes),

  /**
   * Sets right margin. One of 'none', 'small-2', 'small-1', 'small', 'medium', 'large', 'large+1', 'large+2', 'large+3', 'large+4'.
   */
  marginRight: _propTypes.default.oneOf(arrayOfSpacerSizes),

  /**
   * Sets padding in a syntax similar to the standard CSS spec https://developer.mozilla.org/en-US/docs/Web/CSS/padding. One of 'none', 'small-2', 'small-1', 'small', 'medium', 'large', 'large+1', 'large+2', 'large+3', 'large+4'.
   */
  padding: _spacerShorthandUtils.shorthandValidator,

  /**
   * Sets top padding. One of 'none', 'small-2', 'small-1', 'small', 'medium', 'large', 'large+1', 'large+2', 'large+3', 'large+4'.
   */
  paddingTop: _propTypes.default.oneOf(arrayOfSpacerSizes),

  /**
   * Sets bottom padding. One of 'none', 'small-2', 'small-1', 'small', 'medium', 'large', 'large+1', 'large+2', 'large+3', 'large+4'.
   */
  paddingBottom: _propTypes.default.oneOf(arrayOfSpacerSizes),

  /**
   * Sets left padding. One of 'none', 'small-2', 'small-1', 'small', 'medium', 'large', 'large+1', 'large+2', 'large+3', 'large+4'.
   */
  paddingLeft: _propTypes.default.oneOf(arrayOfSpacerSizes),

  /**
   * Sets right padding. One of 'none', 'small-2', 'small-1', 'small', 'medium', 'large', 'large+1', 'large+2', 'large+3', 'large+4'.
   */
  paddingRight: _propTypes.default.oneOf(arrayOfSpacerSizes),

  /**
   * Sets the display to be inline-block.
   */
  isInlineBlock: _propTypes.default.bool
};
var defaultProps = {
  margin: undefined,
  marginTop: _spacerConstants.SpacerSizes.NONE,
  marginBottom: _spacerConstants.SpacerSizes.NONE,
  marginRight: _spacerConstants.SpacerSizes.NONE,
  marginLeft: _spacerConstants.SpacerSizes.NONE,
  padding: undefined,
  paddingTop: _spacerConstants.SpacerSizes.NONE,
  paddingBottom: _spacerConstants.SpacerSizes.NONE,
  paddingLeft: _spacerConstants.SpacerSizes.NONE,
  paddingRight: _spacerConstants.SpacerSizes.NONE,
  isInlineBlock: false
};

var Spacer = function Spacer(_ref) {
  var margin = _ref.margin,
      marginTop = _ref.marginTop,
      marginBottom = _ref.marginBottom,
      marginLeft = _ref.marginLeft,
      marginRight = _ref.marginRight,
      padding = _ref.padding,
      paddingTop = _ref.paddingTop,
      paddingBottom = _ref.paddingBottom,
      paddingLeft = _ref.paddingLeft,
      paddingRight = _ref.paddingRight,
      isInlineBlock = _ref.isInlineBlock,
      children = _ref.children,
      customProps = _objectWithoutProperties(_ref, _excluded);

  var theme = _react.default.useContext(_terraThemeContext.default);

  var marginShorthand = margin ? (0, _spacerShorthandUtils.mapShorthandToObject)('margin', margin) : {};
  var paddingShorthand = padding ? (0, _spacerShorthandUtils.mapShorthandToObject)('padding', padding) : {};

  var marginAttributes = _objectSpread({
    marginTop: marginTop,
    marginRight: marginRight,
    marginBottom: marginBottom,
    marginLeft: marginLeft
  }, marginShorthand);

  var paddingAttributes = _objectSpread({
    paddingTop: paddingTop,
    paddingRight: paddingRight,
    paddingBottom: paddingBottom,
    paddingLeft: paddingLeft
  }, paddingShorthand);

  var SpacerClassNames = (0, _classnames.default)(cx("margin-top-".concat(_spacerConstants.SpacerClassMappings[marginAttributes.marginTop]), "margin-bottom-".concat(_spacerConstants.SpacerClassMappings[marginAttributes.marginBottom]), "margin-left-".concat(_spacerConstants.SpacerClassMappings[marginAttributes.marginLeft]), "margin-right-".concat(_spacerConstants.SpacerClassMappings[marginAttributes.marginRight]), "padding-top-".concat(_spacerConstants.SpacerClassMappings[paddingAttributes.paddingTop]), "padding-bottom-".concat(_spacerConstants.SpacerClassMappings[paddingAttributes.paddingBottom]), "padding-left-".concat(_spacerConstants.SpacerClassMappings[paddingAttributes.paddingLeft]), "padding-right-".concat(_spacerConstants.SpacerClassMappings[paddingAttributes.paddingRight]), {
    'is-inline-block': isInlineBlock
  }, theme.className), customProps.className);
  return /*#__PURE__*/_react.default.createElement("div", _extends({}, customProps, {
    className: SpacerClassNames
  }), children);
};

var opts = {
  Sizes: _spacerConstants.SpacerSizes
};
Spacer.propTypes = propTypes;
Spacer.defaultProps = defaultProps;
Spacer.Opts = opts;
var _default = Spacer;
exports.default = _default;